using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;

namespace XMLWindows
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtArchivo;
		private System.Windows.Forms.Button btnCargar;
		private System.Windows.Forms.TreeView treeXML;
	
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.txtArchivo = new System.Windows.Forms.TextBox();
			this.btnCargar = new System.Windows.Forms.Button();
			this.treeXML = new System.Windows.Forms.TreeView();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Archivo";
			// 
			// txtArchivo
			// 
			this.txtArchivo.Location = new System.Drawing.Point(64, 8);
			this.txtArchivo.Name = "txtArchivo";
			this.txtArchivo.Size = new System.Drawing.Size(240, 20);
			this.txtArchivo.TabIndex = 1;
			this.txtArchivo.Text = "";
			// 
			// btnCargar
			// 
			this.btnCargar.Location = new System.Drawing.Point(312, 8);
			this.btnCargar.Name = "btnCargar";
			this.btnCargar.TabIndex = 2;
			this.btnCargar.Text = "Cargar";
			this.btnCargar.Click += new System.EventHandler(this.btnCargar_Click);
			// 
			// treeXML
			// 
			this.treeXML.ImageIndex = -1;
			this.treeXML.Location = new System.Drawing.Point(8, 40);
			this.treeXML.Name = "treeXML";
			this.treeXML.SelectedImageIndex = -1;
			this.treeXML.Size = new System.Drawing.Size(376, 432);
			this.treeXML.TabIndex = 3;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 486);
			this.Controls.Add(this.treeXML);
			this.Controls.Add(this.btnCargar);
			this.Controls.Add(this.txtArchivo);
			this.Controls.Add(this.label1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnCargar_Click(object sender, System.EventArgs e)
		{
			//borrar el rbol
			treeXML.Nodes.Clear();

			//cargar un XML Document (System.XML)
			XmlDocument doc = new XmlDocument();

			try
			{
				doc.Load(this.txtArchivo.Text);
			}
			catch(Exception error)
			{
				MessageBox.Show(error.Message);
				return;
			}

			//poblar el rbol
			ConvertirNodoXMLaNodoTree(doc, treeXML.Nodes);

			//expandir todos los nodos
			treeXML.Nodes[0].ExpandAll();
		}

		private void ConvertirNodoXMLaNodoTree(XmlNode xmlNode, TreeNodeCollection treeNodes)
		{
				//adicionar un Nodo de rbol correspondiente al nodo XML
				TreeNode nuevoTreeNode = treeNodes.Add(xmlNode.Name);

			switch(xmlNode.NodeType)
			{
					case XmlNodeType.ProcessingInstruction :
				case XmlNodeType.XmlDeclaration :
					nuevoTreeNode.Text = xmlNode.Name + " " + xmlNode.Value;
					break;
				case XmlNodeType.Element:
					nuevoTreeNode.Text = "<" + xmlNode.Name + ">";
					break;
				case XmlNodeType.Attribute:
					nuevoTreeNode.Text = "Atributo : " + xmlNode.Name;
					break;
				case XmlNodeType.Text:
				case XmlNodeType.CDATA:
					nuevoTreeNode.Text = xmlNode.Value;
					break;
				case XmlNodeType.Comment:
					nuevoTreeNode.Text = "<!-- " + xmlNode.Value + " -->";
					break;
			}

			//llamar recursivamente para cada atributo
			if (xmlNode.Attributes != null) 
			{
				foreach (XmlAttribute atributo in xmlNode.Attributes)
				{
					ConvertirNodoXMLaNodoTree(atributo, nuevoTreeNode.Nodes);
				}
			}

				foreach(XmlNode nodoHijo in xmlNode.ChildNodes)
				{
					ConvertirNodoXMLaNodoTree(nodoHijo, nuevoTreeNode.Nodes);
				}

		}

	}
}
